<?php

namespace Drupal\ckenbsp\Plugin\CKEditor5Plugin;

use Drupal\ckeditor5\Plugin\CKEditor5PluginConfigurableInterface;
use Drupal\ckeditor5\Plugin\CKEditor5PluginConfigurableTrait;
use Drupal\ckeditor5\Plugin\CKEditor5PluginDefault;
use Drupal\Core\Form\FormStateInterface;
use Drupal\editor\EditorInterface;

/**
 * CKEditor 5 NBSP plugin configuration.
 *
 * @internal
 *   Plugin classes are internal.
 */
class Ckenbsp extends CKEditor5PluginDefault implements CKEditor5PluginConfigurableInterface {

  use CKEditor5PluginConfigurableTrait;

  const T_CONTEXT = ['context' => 'ckenbsp module'];

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form['div'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('No NBSP as DIV empty filler', [], self::T_CONTEXT),
      '#description' => $this->t('It helps to leave empty DIV.', [], self::T_CONTEXT),
      '#default_value' => $this->configuration['div'],
    ];
    $form['p'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('No NBSP as P empty filler', [], self::T_CONTEXT),
      '#description' => $this->t('It helps to leave empty P.', [], self::T_CONTEXT),
      '#default_value' => $this->configuration['p'],
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
    ;
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $fieldNames = ['div', 'p'];

    foreach($fieldNames as $fieldName) {
      $this->configuration[$fieldName] = $form_state->getValue($fieldName);
    }
  }

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [
      'div' => false,
      'p' => false,
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getDynamicPluginConfig(array $static_plugin_config, EditorInterface $editor): array {
    return [
      'ckenbsp' => $this->configuration,
    ];
  }

}
